%global rev .741
%global fullversion %{version}%{?rev}

Name:          openid4java
Version:       0.9.8
Release:       1%{?dist}
Summary:       This library allows you to OpenID-enable your Java web-app
Group:         Development/Libraries
License:       ASL 2.0
URL:           http://code.google.com/p/openid4java/
Source0:       http://openid4java.googlecode.com/files/openid4java-%{fullversion}.tar.gz
# build fix for ehcache-core >= 2.x
Patch0:        %{name}-0.9.6.662-ehcache-core.patch

BuildRequires: java-devel

BuildRequires: apache-commons-codec
BuildRequires: apache-commons-logging
BuildRequires: atinject
BuildRequires: ehcache-core
BuildRequires: google-guice
BuildRequires: httpcomponents-client
BuildRequires: httpcomponents-core
BuildRequires: log4j
BuildRequires: nekohtml
BuildRequires: springframework
BuildRequires: springframework-beans
BuildRequires: springframework-jdbc
BuildRequires: springframework-tx
BuildRequires: tomcat-jsp-2.2-api
BuildRequires: tomcat-servlet-3.0-api
BuildRequires: xerces-j2

# test deps
BuildRequires: apache-commons-io
BuildRequires: cglib
BuildRequires: hsqldb
BuildRequires: jdom
BuildRequires: junit
BuildRequires: log4j
BuildRequires: xml-commons-apis

BuildRequires: maven-local
BuildRequires: maven-antrun-plugin
BuildRequires: properties-maven-plugin

Requires:      atinject
Requires:      apache-commons-codec
Requires:      apache-commons-logging
Requires:      ehcache-core
Requires:      google-guice
Requires:      httpcomponents-client
Requires:      httpcomponents-core
Requires:      log4j
Requires:      nekohtml
Requires:      springframework
Requires:      springframework-beans
Requires:      springframework-jdbc
Requires:      springframework-tx
Requires:      tomcat-jsp-2.2-api
Requires:      tomcat-servlet-3.0-api
Requires:      xerces-j2

Requires:      java
BuildArch:     noarch

%description
OpenID4Java library offers support for OpenID-enabling a
consumer site or implementing an OpenID Provider server.

%package javadoc
Group:         Documentation
Summary:       Javadoc for %{name}

%description javadoc
This package contains javadoc for %{name}.

%prep
%setup -q -n %{name}-%{fullversion}
%patch0 -p0

find -name '*.class' -delete
find -name '*.jar' -delete
rm -rf openid4java.ai
rm -rf apidoc/*

%pom_remove_plugin :cobertura-maven-plugin
%pom_remove_plugin :findbugs-maven-plugin
#%%pom_remove_plugin :maven-antrun-plugin
%pom_remove_plugin :maven-assembly-plugin
%pom_remove_plugin :maven-checkstyle-plugin
%pom_remove_plugin :maven-pmd-plugin
%pom_remove_plugin :maven-source-plugin
%pom_remove_plugin :rat-maven-plugin
%pom_remove_plugin :taglist-maven-plugin
%pom_remove_plugin :versions-maven-plugin
%pom_xpath_remove "pom:build/pom:plugins/pom:plugin[pom:artifactId ='maven-javadoc-plugin']"

%pom_remove_dep xml-security:xmlsec

%pom_add_dep javax.inject:javax.inject
%pom_add_dep commons-codec:commons-codec
%pom_add_dep org.apache.httpcomponents:httpcore
%pom_add_dep org.springframework:spring-core
%pom_add_dep org.springframework:spring-beans
%pom_add_dep org.springframework:spring-tx
%pom_remove_dep javax.servlet:servlet-api
%pom_add_dep org.apache.tomcat:tomcat-servlet-api
%pom_add_dep org.apache.tomcat:tomcat-jsp-api

# require org.openxri
# org.openxri:openxri-syntax
# org.openxri:openxri-client
rm -r src/org/openid4java/discovery/xri/LocalXriResolver.java

# require: org.eclipse.higgins
# org.eclipse.higgins:higgins-configuration-api
# org.eclipse.higgins:higgins-sts-api
# org.eclipse.higgins:higgins-sts-common
# org.eclipse.higgins:higgins-sts-server-token-handler
# org.eclipse.higgins:higgins-sts-spi
# org.apache.ws.commons.axiom:axiom-api
rm -r src/org/openid4java/infocard \
  test/src/org/openid4java/infocard

# unavailable test deps
%pom_remove_dep jetty:jetty
%pom_remove_dep jetty:jetty-util
%pom_remove_dep net.sourceforge.jwebunit:jwebunit-htmlunit-plugin
rm -r test/src/org/openid4java/discovery/yadis/YadisResolverTest.java \
  test/src/org/openid4java/samples/ConsumerAndProviderTest.java \
  test/src/org/openid4java/consumer/ConsumerManagerTest.java

%pom_remove_dep net.sf.ehcache:ehcache
%pom_add_dep net.sf.ehcache:ehcache-core

# this test fails
rm -r test/src/org/openid4java/consumer/EhcacheNonceVerifierTest.java

%pom_add_dep commons-io:commons-io::test
%pom_add_dep net.sf.cglib:cglib::test

%build
# @ random tests fails
# e.g. Failed tests:   testNonceCleanup(org.openid4java.consumer.JdbcNonceVerifierTest): expected:<0> but was:<3>
mvn-rpmbuild package javadoc:aggregate

%install

mkdir -p %{buildroot}%{_javadir}
install -m 644 target/%{name}-%{version}.jar %{buildroot}%{_javadir}/%{name}.jar

(
  cd %{buildroot}%{_javadir}
  ln -sf %{name}.jar %{name}-nodeps.jar
)

mkdir -p %{buildroot}%{_mavenpomdir}
install -pm 644 pom.xml %{buildroot}%{_mavenpomdir}/JPP-%{name}.pom
%add_maven_depmap JPP-%{name}.pom %{name}.jar

mkdir -p %{buildroot}%{_javadocdir}/%{name}
rm -rf target/site/apidocs/javadoc.sh
cp -rp target/site/apidocs/* %{buildroot}%{_javadocdir}/%{name}

%files
%{_javadir}/%{name}*.jar
%{_mavenpomdir}/JPP-%{name}.pom
%{_mavendepmapfragdir}/%{name}
%doc CHANGELOG LICENSE MAINTAINERS README TODO VERSION

%files javadoc
%{_javadocdir}/%{name}
%doc LICENSE

%changelog
* Fri May 31 2013 gil cattaneo <puntogil@libero.it> 0.9.8-1
- update to 0.9.8.741

* Sun May 12 2013 gil cattaneo <puntogil@libero.it> 0.9.7-1
- update to 0.9.7.720

* Fri Nov 16 2012 gil cattaneo <puntogil@libero.it> 0.9.6-1
- initial rpm